#---------------------------------------------------
# 饹߷
#---------------------------------------------------

#---- ե
$adjust_file = "time_adjust.txt"


#----------------------------------
# ͽ󥢥ƥ९饹
#
class RecordItem
  #-------------------------------------
  #----- ѥ᡼
  # line = Ͽͽǡʬ
  def initialize(line)
    @item_val = line.split
    @item_val[2] = @item_val[2].to_i
    @item_val[4] = @item_val[4].to_i
    @item_val[3] =~ /([0-9]+):([0-9]+)/
    @item_val[6] = $1.to_i
    @item_val[7] = $2.to_i
    # --- ꥸʥͽǡ¸
    @item_org = line
    # --- μ
    @rec_adjust = 0
    if File::exist?($adjust_file)
      #-- ɤ߹
      File::foreach($adjust_file) do |line|
        if (line =~ /^[\s\t]*$/) || (line =~ /^#/)
          next
        end
        @rec_adjust = line.to_i
      end
    end
  end

  #-------------------------------------
  #----- Ǥᤤ̤֤(sec)
  def onair
    #--- ߤλ
    nowtime = Time::now
    nowtime -= @rec_adjust
    #--- ֺ
    ad_d = 0
    nt = (((nowtime.hour * 60) + nowtime.min) * 60) + nowtime.sec
    it = (((@item_val[6] * 60) + @item_val[7]) * 60)
    if nt > it
      dt = (24*60*60 + it) - nt
      ad_d = 1
    else
      dt = it - nt
    end
    #--- 鲿ΥƤ뤫׻
    if nowtime.wday > (@item_val[2] - ad_d)
      dw = ((@item_val[2] - ad_d + 7) - nowtime.wday) * (24 * 60 * 60)
    else
      dw = (@item_val[2] - ad_d - nowtime.wday) * (24 * 60 * 60)
    end
    (dw + dt)
  end


  #-------------------------------------
  #----- ϿȤǤ뤫ɤ
  def recnow?
    ret = false
    #--- ߤλ
    nowtime = Time::now
    nowtime -= @rec_adjust
    #--- ֺ
    ad_d = 0
    nt = (((nowtime.hour * 60) + nowtime.min) * 60) + nowtime.sec
    it = (((@item_val[6] * 60) + @item_val[7]) * 60)
    if it > nt
      dt = (24*60*60 + nt) - it
      ad_d = 1
    else
      dt = nt - it
    end
    #--- 鲿ΥƤ뤫׻
    if nowtime.wday > (@item_val[2] - ad_d)
      dw = ((@item_val[2] - ad_d + 7) - nowtime.wday) * (24 * 60 * 60)
    else
      dw = (@item_val[2] - ad_d - nowtime.wday) * (24 * 60 * 60)
    end
    #--- ϻ֤ɤ줯餤ΥƤ뤫
    dsec = (dw + dt)
    #
    if dsec < (@item_val[4] * 60)
      ret = true
    end
    #
    ret
  end


  #-------------------------------------
  #----- ǤǶ줿֤
  def recent_onair
    #--- ߤλ
    nowtime = Time::now
    dd = ((nowtime.wday - radio_week) + 7) % 7
    nowtime -= (dd * (24*60*60))
    filename = sprintf("%02d%02d%02d%02d",
                       nowtime.month,
                       nowtime.day,
                       @item_val[6],
                       @item_val[7])
    filename
  end


  #-------------------------------------
  #----- 饸Υȥ֤
  def radio_fulltitle
    @item_val[0]
  end

  #-------------------------------------
  #----- 饸Υե̾եå֤
  def radio_title
    @item_val[1]
  end

  #-------------------------------------
  #----- 饸֤
  def radio_week
    @item_val[2]
  end

  #-------------------------------------
  #----- 饸֤֤(min)
  def radio_length
    @item_val[4]
  end

  #-------------------------------------
  #----- 饸Ͽ֤ͥ
  def radio_line
    @item_val[5]
  end

  #-------------------------------------
  #----- 饸γϻ֤֤(min)
  def radio_time
    (@item_val[6] * 60) + @item_val[7]
  end

  #-------------------------------------
  #----- ꥸʥͽ󥳥ޥ
  def radio_record_line
    @item_org
  end

end


#----------------------------------
# Ͽͽꥹȥ饹
#
class RecordList
  #-------------------------------------
  #----- ѥ᡼
  # listname ϿꥹȤΥե̾
  def initialize(listname)
    unless File::exist?(listname)
      print "listfile not found. ("+listname+")\n"
      exit
    end 
    @item = []
    File::foreach(listname) do |line|
      if (line =~ /^[\s\t]*$/) || (line =~ /^#/)
	next
      end
      @item.push(RecordItem.new(line));
    end
  end

  #-------------------------------------
  #----- ǤᤤȤ֤
  def nearest
    @nitem = nil
    near = (24*60*60*7)
    @item.each do |pitem|
      if near > pitem.onair
        near = pitem.onair
        @nitem = pitem
      end
    end
    # -- nitem = Ǥ˶ᤤ
    @nitem
  end

  #-------------------------------------
  #----- Ȱ֤
  def get_list
    @item
  end

end


